#include "windos.ch"
MemVar   PrtLPI,  PrtPitch,  PrtPaper,  PrtOrient, PrtReset

STATIC oTerm

/***
   Straight forward program to maintain the terms of payment table
***/
PROCEDURE WDDTerm
   LOCAL oDlg, oBrw
   LOCAL cDummy, cBrw

      // Open the tables required for this operation
      DEFINE TABLE WdTerms AS oTerm    INDEX WdTerms NEW

      DEFINE DIALOG oDlg FROM 1,1 TO 23,60 ;
           TITLE "Payment Terms Table"

      DEFINE BROWSE oBrw VAR cBrw OF oDlg ;
           FROM 4,2 TO 18,54 ;
           ALIAS WdTerms ;
           FIELDS WdTerms->Code,WdTerms->Desc ;
           HEADERS "Terms;Code",";Description" ;
           VSCROLL ;
           NOBAR ;
           MESSAGE "Select Item"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 3 ;
           ACTION {|| oDlg:end() } ;
           CAPTION "Close" ;
           MESSAGE "Push Here to Exit"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 14 ;
           ACTION {|| PrtReport(oBrw)} ;
           WHEN !( oTerm:eof() ) ;
           CAPTION "Print" ;
           MESSAGE "Push Here to Print Terms List"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 25 ;
           ACTION {|| WDDTermData(.F.),oBrw:refresh() } ;
           WHEN !( oTerm:eof() ) ;
           CAPTION "Modify" ;
           MESSAGE "Push Here to Modify Selected Item"

      DEFINE PUSHBUTTON VAR cDummy OF oDlg ;
           AT 0, 36 ;
           ACTION {|| WDDTermData(.T.),oBrw:gotop(),oBrw:refresh() } ;
           CAPTION "Add" ;
           MESSAGE "Push Here to Add New Item"

      ACTIVATE DIALOG oDlg CENTERED
      CLOSE DATABASES
   RETURN

STATIC PROCEDURE PrtReport(oBrw)
      IF ReportDlg("Payment Terms Table") = 1
        oBrw:report("Payment Terms Table",35,PrtReset,PrtOrient,PrtPitch,PrtLPI)
      ENDIF
   RETURN

PROCEDURE WDDTermData( lNew )
   LOCAL oDlg, cBtn1, cBtn2

      IF lNew
        oTerm:empty()
        oTerm:code := GetNextCode( oTerm )
      ELSE
        oTerm:load()
      ENDIF

      DEFINE DIALOG oDlg FROM 5,10 TO 19,60 ;
         TITLE "Payment Terms Information"

      DEFINE SAY VAR oTerm:Code OF oDlg ;
         AT 1, 15 ;
         FRAME ;
         COLOR "N/W,W/B" ;
         CAPTION "Code:"

      DEFINE GET VAR oTerm:Desc OF oDlg ;
         AT  3,15 ;
         FRAME ;
         COLOR "N/W,W/B";
         CAPTION "Description:" ;
         MESSAGE "Enter the Description for this Item"

      DEFINE PUSHBUTTON VAR cBtn1 OF oDlg ;
         AT 11, 5 ;
         ACTION {|| oDlg:end() } ;
         CAPTION "Close"

      DEFINE PUSHBUTTON VAR cBtn2 OF oDlg ;
         AT 11, 16 ;
         ACTION SaveTerm( lNew, oDlg ) ;
         CAPTION "Save"

      ACTIVATE DIALOG oDlg
   RETURN

STATIC FUNCTION SaveTerm( lNew, oDlg )
      IF Empty(oTerm:desc)
        MsgBeep()
        MsgOk("Terms Data","Description Must be Entered")
        oDlg:GetNext( 1 )
      ELSE
        SaveRecord( lNew, oDlg, oTerm )
      ENDIF
   RETURN ( NIL )
